.586
.MODEL FLAT,STDCALL
OPTION CASEMAP:NONE

INCLUDE \masm32\include\windows.inc

INCLUDE \masm32\include\kernel32.inc
;INCLUDE \masm32\include\user32.inc
INCLUDE \masm32\include\oleaut32.inc
INCLUDE \masm32\include\msvcrt.inc
INCLUDE \masm32\include\masm32.inc
INCLUDE \masm32\include\DateTime.inc


INCLUDE \masm32\macros\macros.asm

INCLUDELIB \masm32\lib\kernel32.lib
;INCLUDELIB \masm32\lib\user32.lib
INCLUDELIB \masm32\lib\oleaut32.lib
INCLUDELIB \masm32\lib\msvcrt.lib
INCLUDELIB \masm32\lib\masm32.lib
INCLUDELIB \masm32\lib\DateTime.lib
;INCLUDELIB "D:\ASM\MASM32\Libraries\GEL32\DateTime\DateTime.lib"

main          PROTO
PrintDateTime PROTO pdt:PTR DATETIME

newline MACRO
    INVOKE StdOut, SADD(13,10)
ENDM

PrintBoolean MACRO x:REQ
    .IF x == FALSE
        INVOKE StdOut, SADD("False")
    .ELSE
        INVOKE StdOut, SADD("True")
    .ENDIF
ENDM

.DATA

    ALIGN 8
    dtTest DATETIME   190AC86B403B780h

.CODE

start:

    call main
    INVOKE ExitProcess, eax

main PROC

    ALIGN 8
    LOCAL dtLocal:DATETIME
    LOCAL dtUtc:DATETIME
    LOCAL dtCopy:DATETIME
    LOCAL dtDstStart:DATETIME
    LOCAL dtDstEnd:DATETIME
    LOCAL dtParsed:DATETIME
    LOCAL dtTemp:DATETIME
    LOCAL dtMax:DATETIME

    LOCAL dblOffsetHr:REAL8

    LOCAL dwYear:DWORD
    LOCAL dwMonth:DWORD
    LOCAL dwDay:DWORD
    LOCAL dwHour:DWORD
    LOCAL dwMinute:DWORD
    LOCAL dwSecond:DWORD
    LOCAL dwTmp:DWORD

    LOCAL sdwCompare:SDWORD
    LOCAL sdwOffsetMin:SDWORD
    LOCAl sdwDays:SDWORD

    LOCAL szBuff[256]:BYTE
    LOCAL pszBuff:PBYTE

    lea eax, szBuff
    mov pszBuff, eax

    INVOKE GetLocalDateTime, ADDR dtLocal
    INVOKE GetUtcDateTime, ADDR dtUtc
    print "Local:                              "
    INVOKE PrintDateTime, ADDR dtLocal
    print "Utc:                                "
    INVOKE DateTimeToStringLong24, ADDR dtUtc, pszBuff
    print pszBuff
    newline

    mov sdwDays, 30
    INVOKE DateAdd, SADD("d"), ADDR sdwDays, ADDR dtLocal, ADDR dtTemp
    print "Local plus 30 days:                 "
    INVOKE PrintDateTime, ADDR dtTemp

    INVOKE DateDiff, SADD("m"), ADDR dtUtc, ADDR dtLocal, ADDR sdwOffsetMin
    print "Difference from Utc to Local:       "
    print sdword$(sdwOffsetMin)
    print " minutes"
    newline

    INVOKE DateDiffTotal, SADD("h"), ADDR dtUtc, ADDR dtLocal, ADDR dblOffsetHr
    print "Difference from Utc to Local:       "
    print real8$(dblOffsetHr)
    print " hours"
    newline

    INVOKE CompareDateTime, ADDR dtUtc, ADDR dtLocal
    mov sdwCompare, eax
    print "Compare Utc to Local:               "
    .IF sdwCompare == 0
        print "Equal"
    .ELSEIF sdwCompare == -1
        print "Less than"
    .ELSEIF sdwCompare == 1
        print "Greater than"
    .ELSE
        print "Compare error!"
    .ENDIF
    newline

    INVOKE CopyDateTime, ADDR dtLocal, ADDR dtCopy
    print "Copy of Local:                      "
    INVOKE PrintDateTime, ADDR dtCopy

    INVOKE CurrentTimeZoneName, ADDR szBuff
    print "Current Time Zone name:             "
    print pszBuff
    newline

    INVOKE CurrentUtcOffsetInMinutes, ADDR sdwOffsetMin
    print "UTC offset in minutes:              "
    print sdword$(sdwOffsetMin)
    newline

    INVOKE CurrentUtcOffsetInHours, ADDR dblOffsetHr
    print "UTC offset in hours:                "
    print real8$(dblOffsetHr)
    newline

    INVOKE DateTimeToDateString, ADDR dtLocal, pszBuff
    print "Date only string (default):         "
    print pszBuff
    newline

    INVOKE DateTimeToDateStringLong, ADDR dtLocal, pszBuff
    print "Date only string (long):            "
    print pszBuff
    newline

    INVOKE DateTimeToDateStringShort, ADDR dtLocal, pszBuff
    print "Date only string (short):           "
    print pszBuff
    newline

    INVOKE DateTimeToString, ADDR dtLocal, pszBuff
    print "Date and time string (default):     "
    print pszBuff
    newline

    INVOKE DateTimeToStringFormat, ADDR dtLocal, SADD("M/d/yyyy"), SADD("h:mm:ss tt"), pszBuff
    print "Date and time string (custom):      "
    print pszBuff
    newline

    INVOKE DateTimeToStringLong, ADDR dtLocal, pszBuff
    print "Date and time string (long):        "
    print pszBuff
    newline

    INVOKE DateTimeToStringLong12, ADDR dtLocal, pszBuff
    print "Date and time string (long 12):     "
    print pszBuff
    newline

    INVOKE DateTimeToStringLong24, ADDR dtLocal, pszBuff
    print "Date and time string (long 24):     "
    print pszBuff
    newline

    INVOKE DateTimeToStringShort, ADDR dtLocal, pszBuff
    print "Date and time string (short):       "
    print pszBuff
    newline

    INVOKE DateTimeToStringShort12, ADDR dtLocal, pszBuff
    print "Date and time string (short 12):    "
    print pszBuff
    newline

    INVOKE DateTimeToStringShort24, ADDR dtLocal, pszBuff
    print "Date and time string (short 24):    "
    print pszBuff
    newline

    INVOKE DateTimeToTimeString, ADDR dtLocal, pszBuff
    print "Time only string (default):         "
    print pszBuff
    newline

    INVOKE DateTimeToTimeString12, ADDR dtLocal, pszBuff
    print "Time only string (12-hour):         "
    print pszBuff
    newline

    INVOKE DateTimeToTimeString24, ADDR dtLocal, pszBuff
    print "Time only string (24-hour):         "
    print pszBuff
    newline

    print "DateTimeToYMDHMS"
    newline
    INVOKE DateTimeToYMDHMS, ADDR dtLocal, ADDR dwYear, ADDR dwMonth, ADDR dwDay, ADDR dwHour, ADDR dwMinute, ADDR dwSecond
    print "  Year:                             "
    print udword$(dwYear)
    newline
    print "  Month:                            "
    print udword$(dwMonth)
    newline
    print "  Day:                              "
    print udword$(dwDay)
    newline
    print "  Hour:                             "
    print udword$(dwHour)
    newline
    print "  Minute:                           "
    print udword$(dwMinute)
    newline
    print "  Second:                           "
    print udword$(dwSecond)
    newline

    INVOKE Year, ADDR dtLocal
    mov dwYear, eax
    print "Year                                "
    print udword$(dwYear)
    newline

    INVOKE Month, ADDR dtLocal
    mov dwMonth, eax
    print "Month                               "
    print udword$(dwMonth)
    newline

    INVOKE Day, ADDR dtLocal
    mov dwDay, eax
    print "Day                                 "
    print udword$(dwDay)
    newline

    INVOKE Hour, ADDR dtLocal
    mov dwHour, eax
    print "Hour                                "
    print udword$(dwHour)
    newline

    INVOKE Minute, ADDR dtLocal
    mov dwMinute, eax
    print "Minute                              "
    print udword$(dwMinute)
    newline

    INVOKE Second, ADDR dtLocal
    mov dwSecond, eax
    print "Second                              "
    print udword$(dwSecond)
    newline

    INVOKE Year, ADDR dtLocal
    mov dwYear, eax
    INVOKE DaylightSavingTimeStartDateTime, dwYear, ADDR dtDstStart
    print "DST starts (this year):             "
    INVOKE PrintDateTime, ADDR dtDstStart

    INVOKE DaylightSavingTimeEndDateTime, dwYear, ADDR dtDstEnd
    print "DST ends (this year)                "
    INVOKE PrintDateTime, ADDR dtDstEnd

    INVOKE DayOfWeek, ADDR dtLocal
    mov dwTmp, eax
    print "Day of week (today):                "
    print udword$(dwTmp)
    newline

    INVOKE DayOfWeekName, ADDR dtLocal, pszBuff
    print "Day of week name (today)            "
    print pszBuff
    newline

    INVOKE MonthName, ADDR dtLocal, pszBuff
    print "Month name (today)                  "
    print pszBuff
    newline

    INVOKE DayOfYear, ADDR dtLocal
    mov dwTmp, eax
    print "Day of year (today):                "
    print udword$(dwTmp)
    newline

    INVOKE DaysInMonth, ADDR dtLocal
    mov dwTmp, eax
    print "Days in this month:                 "
    print udword$(dwTmp)
    newline

    INVOKE IsDaylightSavingTime, ADDR dtLocal, ADDR dwTmp
    print "Is it DST now?                      "
    .IF dwTmp == 0
        print "False"
    .ELSE
        print "True"
    .ENDIF
    newline

    INVOKE IsLeapYear, dwYear
    mov dwTmp, eax
    print "Is this year a Leap Year?           "
    .IF dwTmp == 0
        print "False"
    .ELSE
        print "True"
    .ENDIF
    newline

    INVOKE StringToDateTime, SADD("5/22/1958 1:02:03 AM"), ADDR dtParsed
    print "DATETIME from parsed string:        "
    INVOKE PrintDateTime, ADDR dtParsed

    INVOKE YMDHMSToDateTime, 1958, 5, 22, 1, 2, 3, ADDR dtTemp
    print "DATETIME from YMDHMSToDateTime:     "
    INVOKE PrintDateTime, ADDR dtTemp

    mov DWORD PTR [dtTemp+0], 0
    mov DWORD PTR [dtTemp+4], 0
    print "DATETIME = 0 (min):                 "
    INVOKE PrintDateTime, ADDR dtTemp

    print "DATETIME = "
    print xqword$(dtTest)
    print "h:        "
    INVOKE PrintDateTime, ADDR dtTest

    INVOKE YMDHMSToDateTime, 30827, 12, 31, 23, 59, 59, ADDR dtMax  ; Maximum SYSTEMTIME wYear is 30827
    print "DATETIME = "
    print xqword$(dtMax)
    print "h (max): "
    INVOKE PrintDateTime, ADDR dtMax

    ; waitkey
    newline
    inkey SADD("Press any key to exit ... ")
    newline

    xor eax, eax
    ret
main ENDP
;----------------------------------------------------
PrintDateTime PROC pdt:PTR DATETIME

    LOCAL szBuffer[256]:BYTE

    mov BYTE PTR szBuffer, 0
    INVOKE DateTimeToString, pdt, ADDR szBuffer
    INVOKE StdOut, ADDR szBuffer
    INVOKE StdOut, SADD(13,10)

    ret

PrintDateTime ENDP
;----------------------------------------------------
END start
